# Welcome to Django Q2

Django Q2 is a native Django task queue, scheduler and worker application using Python multiprocessing.

Note

Django Q2 is a fork of Django Q. Big thanks to Ilan Steemers for starting this project. Unfortunately, development of Django Q has stalled since June 2021. Django Q2 is the new updated version of Django Q, with dependencies updates, docs updates and several bug fixes. Original repository: https://github.com/Koed00/django-q

## Features

- Multiprocessing worker pools

- Asynchronous tasks

- Scheduled, cron and repeated tasks

- Signed and compressed packages

- Failure and success database or cache

- Result hooks, groups and chains

- Django Admin integration

- PaaS compatible with multiple instances

- Multi cluster monitor

- Redis, IronMQ, SQS, MongoDB or ORM

- Rollbar and Sentry support

Django Q2 is tested with: Python 3.8, 3.9, 3.10, 3.11 and 3.12. Works with Django 4.2.x, 5.x and 6.0.x

Currently available in English, German and French.

Contents:

- Installation
  - Migrate from Django-Q to Django-Q2
  - Requirements
  - Add-ons
- Configuration
  - name
  - workers
  - daemonize_workers
  - recycle
  - max_rss
  - timeout
  - time_zone
  - ack_failures
  - max_attempts
  - retry
  - compress
  - save_limit
  - save_limit_per
  - guard_cycle
  - sync
  - queue_limit
  - label
  - catch_up
  - redis
  - django_redis
  - iron_mq
  - sqs
  - orm
  - mongo
  - mongo_db
  - broker_class
  - bulk
  - poll
  - cache
  - cached
  - scheduler
  - error_reporter
  - cpu_affinity
  - ALT_CLUSTERS
- Brokers
  - Redis
  - IronMQ
  - Amazon SQS
  - MongoDB
  - Django ORM
  - Custom Broker
  - Reference
- Tasks
  - async_task()
  - AsyncTask
  - Cached operations
  - Synchronous testing
  - Connection pooling
  - Reference
- Groups
  - Reference
- Iterable
  - Reference
- Chains
  - Reference
- Schedules
  - Schedule
  - Missed schedules
  - Management Commands
  - Reference
- Cluster
  - Multiple Clusters
  - Multiple Queues
  - Using a Procfile
  - Process managers
  - Reference
- Monitor
  - Legend
  - Info
  - Status
  - Reference
- Admin
  - Successful tasks
  - Failed tasks
  - Scheduled tasks
  - Queued tasks
- Errors
- Signals
  - Available signals
  - Subscribing to a signal
- Architecture
  - Signed Tasks
  - Broker
  - Pusher
  - Worker
  - Monitor
  - Sentinel
  - Timeouts
  - Scheduler
  - Stop procedure
- Examples
  - Emails
  - Signals
  - Reports
  - Haystack
  - Shell
  - Groups
  - Http Health Check

- Index